<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns="http://www.w3.org/2000/svg"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:variable name="W" select="'400'"/>
  <xsl:variable name="H" select="'200'"/>

  <xsl:template match="/stat">
    <svg version="1.1" baseProfile="full"
         height="{$H}" width="{$W}">
      <rect x="0" y="0" width="{$W}" height="{$H}" fill="#181A26"/>

      <text x="5" y="5" dy="1em" font-size="20" fill="#EEEEEE">
        <xsl:value-of select="hist/@title"/> и
        <xsl:value-of select="graph/@title"/>
      </text>

      <!-- Гистограмма -->
      <pattern id="dots" patternUnits="userSpaceOnUse"
               width="5" height="5">
        <rect x="4" y="4" width="1" height="1" fill="#4EEE94"/>
      </pattern>
      <xsl:variable name="hfy" select="$H div hist/@y-max"/>
      <xsl:variable name="w" select="$W div count(hist/block)"/>
      <xsl:for-each select="hist/block">
        <xsl:variable name="h" select=". * $hfy"/>
        <rect x="{$w * (position() - 1)}" y="{$H - $h}"
              width="{$w}" height="{$h}" stroke-width="2"
              fill="url(#dots)" stroke="#4EEE94"/>
      </xsl:for-each>

      <!-- График -->
      <xsl:variable name="fx" select="$W div graph/@x-max"/>
      <xsl:variable name="fy" select="$H div graph/@y-max"/>
      <xsl:variable name="path">
        <xsl:text>M</xsl:text>
        <xsl:for-each select="graph/point">
          <xsl:value-of select="concat(' ', @x * $fx,
                                ' ', $H - @y * $fy, 'L')"/>
        </xsl:for-each>
      </xsl:variable>

      <path d="{$path}" fill="none"
            stroke="#DAA520" stroke-width="4"/>
    </svg>
  </xsl:template>
</xsl:stylesheet>
